/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package i18n;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.MessageFormat;
import java.util.Locale;
import java.util.Properties;
import java.util.ResourceBundle;
import javax.swing.UIManager;

/**
 *
 * @author favdb
 */
public class I18N {

	private static ResourceBundle messageBundle;
	private static Properties propMsg;

	public static final void initMsgFile(String propFileName) {
		propMsg = null;
		if (propFileName==null) {
			return;
		}
		propMsg = new Properties();
		InputStream input;
		try {
			input = new FileInputStream(propFileName);
			propMsg.load(input);
			input.close();
		} catch (IOException ex) {
			System.err.println("messages file error ");
		}
	}

	public static String getColonMsg(String key) {
		return(getMsg(key)+" : ");
	}

	public static String getMsg(String key) {
		return(getMsg(I18N.class, key));
	}

	public static String getMsg(String key, Object [] args) {
		return(I18N.getMsg(I18N.class, key,args));
	}
	
	public static String getMsg(String key, Object arg) {
		return(I18N.getMsg(I18N.class, key,arg));
	}
	
	public static String getMsg(Class<?> c, String key) {
		try {
			String v=propMsg.getProperty(key);
			if (v!=null && !v.isEmpty()) return(v);
			return("???");
		} catch (Exception ex) {
			return '!' + key + '!';
		}
	}

	public static String getMsg(Class<?> c,String key, Object[] args) {
		MessageFormat formatter = new MessageFormat("");
		formatter.setLocale(Locale.getDefault());
		String pattern = getMsg(c,key);
		formatter.applyPattern(pattern);
		return formatter.format(args);
	}

	public static String getMsg(Class<?> c,String key, Object arg) {
		Object[] args = new Object[]{arg};
		return getMsg(c,key, args);
	}

	public static String getLanguage(String key) {
		//App.trace("I18N.getLanguage("+key+")");
		try {
			ResourceBundle rb = ResourceBundle.getBundle("i18n.language");
			return rb.getString(key);
		} catch (Exception ex) {
			System.err.println("language exception:"+ex.getLocalizedMessage()+"\nlanguage="+key);
			return '!' + key + '!';
		}
	}

}
