/*
 * Copyright (C) 2017 favdb
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package i18n;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import net.miginfocom.swing.MigLayout;

/**
 *
 * @author favdb
 */
public class I18NnewDlg extends JDialog implements ActionListener {

	public String language;
	private final JDialog parentDlg;
	private final List<String> languages;
	private JList<String> lsLanguage;
	private final boolean bFile=false;
	private JButton btOk;
	private JButton btCancel;
	
	public I18NnewDlg(JDialog p, List<String> l) {
		super(p);
		languages=l;
		parentDlg=p;
		initAll();
	}
	
	private void initAll() {
		init();
		initUi();
	}

	public void init() {
	}
	
	@SuppressWarnings("unchecked")
	public void initUi() {
		JLabel jLabel1 = new JLabel("Select a language");
		JScrollPane jScrollPane1 = new JScrollPane();
        lsLanguage = new javax.swing.JList<>();
		DefaultListModel model = new DefaultListModel();
		lsLanguage.setModel(model);
		jScrollPane1.setViewportView(lsLanguage);
		
		//layout
		setLayout(new MigLayout(""));
		setTitle("Language");
		add(jLabel1,"wrap");
		add(jScrollPane1,"wrap");
		add(buttonCancel(), "split 2,sg,right");
		add(buttonOk(), "sg, right");
		pack();
		setLocationRelativeTo(null);
		setModal(true);
	}

	public JButton buttonOk() {
		btOk = new JButton("OK");
		btOk.setName("btOK");
		btOk.addActionListener(this);
		return btOk;
	}

	public JButton buttonOk(String str) {
		btOk = buttonOk();
		btOk.setText(str);
		return btOk;
	}

	public JButton buttonCancel() {
		btCancel = new JButton("Cancel");
		btCancel.setName("btCancel");
		btCancel.addActionListener(this);
		return (btCancel);
	}

	public JButton buttonCancel(String str) {
		buttonCancel();
		btCancel.setText(I18N.getMsg(str));
		return btCancel;
	}

	public String getLanguage() {
		return(language);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof JButton) {
			JButton bt=(JButton)e.getSource();
			switch(bt.getName()) {
				case "btOK":
					if (lsLanguage.getSelectedIndex()==-1) return;
					language=(String) lsLanguage.getSelectedValue();
					dispose();
					break;
				case "btCancel":
					language="";
					dispose();
					break;
				case "btClose":
					break;
			}
		}
	}
}
